//+------------------------------------------------------------------+
//|                                        Trade Between Spreads.mq4 |
//|                      Copyright  2007, MetaQuotes Software Corp. |
//|   Created and Written by:  Chin, The Pip Whisperer               |
//|                                        youtube video             | 
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

//---- input parameters

extern bool Place_Trade = true;
extern double RRR=1.9;
extern color Entry_Color=DodgerBlue;
extern color Stop_Color = OrangeRed;
extern color Profit_Color = YellowGreen;  
extern int slippage=1;
double Lots =0;
double Risk = 2.25;
double AccSize = 0;
extern int Split_into = 2;
extern int Grace = 20;
bool Place[30];

double  Trade_Price1=0;
string  Buy_OR_Sell = "Please Enter \'b\' for buy; \'s\' for sell";
string  chart = "none";

int Buy_or_Sell=0;
string comment = "No Active orders for ";
int ticket=-1;
int TakeProfit=0;
double SL=-1, TP=-1;
double Stop_in_Pips=25;
double Target_in_Pips=75;

datetime timelock =-1, timelock2;
bool ready? = false;
double entry,stop,profit,lots=-1,pip,Runit;  //pip is the dollar per pip; Runit is how many $ is per unit risk
string Buy_Sell = "none";
double lomin, himax,hilorange; 
int winbar1,winbar2,winbar3,winbar4;
double tick1, tick2;
double toc1, toc2;
double ask = -1;
double spread;
double temp;
double lll[30];
double lll$[30];

//bool once = true;  //once is going to be turned true if ready? is false.  After ready is turned true, we will check Place_Trade for (T/F) just one time.  This way, our timelock is set only one time.
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   int y;
   ObjectDelete("entry");
   ObjectDelete("stop");
   ObjectDelete("t/p");
   ObjectDelete("Enter # of Lots Below.");
   ObjectDelete("lll_lots$");
//----
//      if (AccSize ==0) AccSize = NormalizeDouble(63489.58+AccountEquity(),2);
      if (Split_into>=30) Split_into =30;  //if they try to split too much, we make it split into 30;
      if (Split_into<1)   Split_into =1;
      chart =  Symbol();  // I am making sure that I know what chart we started with.
      
      if (Place_Trade== false)
          {
           Comment("Trade is turned off");
           Alert("Trade Turned Off");
           return (0);
          }
  
      //----- let's setup the chart flags:
      setup();  
           
      //----- let's turn Place[y] to true for each individual split
      for (y=1 ; y<= 30 ; y++) Place[y] = False;      
      if (Place_Trade == True)
          {
           for (y=1; y<= Split_into; y++) Place[y] = true;  //turn on the ones that are true;
          }                   
     //Write a comment in upper corner to document The Trader's intentions:
 /*    
       if(Buy_Sell == "b" && Place_Trade == True) 
          {comment = "Active Order: Buy @ ";
           TP=Trade_Price1+Target_in_Pips*Point;
           SL=Trade_Price1-Stop_in_Pips*Point;
          }
       if(Buy_Sell == "s" && Place_Trade == True) 
          {comment = "Active Order: Sell @ ";
           TP=Trade_Price1-Target_in_Pips*Point;
           SL=Trade_Price1+Stop_in_Pips*Point;
          }  
       Comment (comment,Trade_Price1,"\nProf. Target= ",TP, "\nStop Loss: ", SL
                ,"\n                     \n                  \n              ");      
   */    
//----
   return(0);
  }
  
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
  // ObjectDelete("entry");
  // ObjectDelete("stop");
  // ObjectDelete("t/p");
  // ObjectDelete("Enter # of Lots Below.");
  // ObjectDelete("lll_lots$");
   ObjectDelete("Active on");
   ObjectDelete("INACTIVE");
   ObjectDelete("Enter # of Lots Below.");   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   int y;
   int x;
   string x$;
//----
   readarrows();
   Trade_Price1 = NormalizeDouble(entry,Digits);   
   Rates_Lots();
   active?();
   
   
   SL=stop;
   TP=profit;

     //Write a comment in upper corner to document The Trader's intentions:     
      if(Buy_Sell == "b" && Place_Trade == True && ready? ==1) 
          {comment = "Active Order: Buy @ ";           
          }
      if(Buy_Sell == "s" && Place_Trade == True && ready? ==1) 
          {comment = "Active Order: Sell @ ";
          }
      //if(TimeLocal()<timelock+Grace) x$=".  Countdown: "+DoubleToStr(timelock+Grace-TimeLocal(),0);  
      // else x$=".";  
      if(TimeLocal()>timelock2+18)
         {                
          Comment (comment,Trade_Price1
                /*,"\nrdy? ", ready?," Trd ", Place_Trade, "; R=$", NormalizeDouble(Lots * MathAbs(entry-stop)/Point*pip,2), " cR=$",Runit, " Acc $",AccSize*/ 
               /* ,"\nSpr ",DoubleToStr(spread/Point,1)*/,"\nEach pip= $",NormalizeDouble(pip,2),"; (Entry - S/L) = ",MathAbs((entry-stop)/Point)," pips ", x$);
         }                  
   //-----if chart has been changed, there is no trade!
   //Check to make sure user has not changed charts:
      if (chart != Symbol())
          {Place_Trade = false;
           Comment("No Trades will be taken because the chart has been changed to a different Pair.  Please Correct");
          }   
      if(AccountFreeMargin()<(1000*Lots))
        {
         Alert("Low on Funds. Free Margin = ", AccountFreeMargin());
         Print("We have no money. Free Margin = ", AccountFreeMargin());
         return(0);  
        }
//............ Buy Order Conditions:
//Split_into=1;  //need this to be 1 for now.
for(y=1; y<=Split_into; y++)//for now, Split_into is set at 1;
   {
   
   if(Buy_Sell == "b" && Ask <= Trade_Price1 && Place_Trade == true && Trade_Price1>0  && ready? == true && lll[y]>0 && Place[y] == true)
      {
       ticket=OrderSend(Symbol(),OP_BUY,lll[y],Ask,slippage,SL,TP,"Visual Trading-- Long",16384,0,Green);
         if(ticket>0)
            {
              if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) 
                 {Print("BUY order opened : ",OrderOpenPrice());
                  Place[y]=False;
                  timelock2=TimeLocal();
                  Alert("Long''ed ",Symbol()," ",OrderLots(), " Lots @", OrderOpenPrice()," For new order, Reload EA.");
                  Comment("Long executed", " ", "@ ",DoubleToStr(OrderOpenPrice(),Digits), " ","\nTake Profit= ",DoubleToStr(TP,Digits),"\nStop Loss =", DoubleToStr(SL,Digits)
                  ,"\nAt Risk: $", NormalizeDouble(  Lots * MathAbs(entry-stop)/Point*pip,2   ) 
                  ,"\n(Entry - S/L) = ", MathAbs((entry-stop)/Point)
                  );                  
                  comment="Long Executed @";
                 } 
            }
         else {
               x=GetLastError();
               x$="";
               if (x==130) x$=" Stop too Tight.";
               if (x==129) x$=" Invalid Price.";
               if (x!=130 && x!=129) x$=" Error Code: "+x;
               Print("Error opening BUY order : ",x); 
               Alert("Error Long, ",Symbol(),x$);
               Comment("Error has occurred ", "on Part ",y,x$);
              }       
      }
//............ Sell Order Conditions:
   if(Buy_Sell == "s" && Bid >= Trade_Price1 && Place_Trade == true  && Trade_Price1>0 && ready? == true && lll[y]>0 && Place[y] == true)   
      {
       ticket=OrderSend(Symbol(),OP_SELL,lll[y],Bid,slippage,SL,TP,"Visual Trading-- Short",16384,0,Red);
         if(ticket>0)
            {
              if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) 
                 {Print("Short order opened : ",OrderOpenPrice());
                  Place[y]= False;
                  timelock2=TimeLocal();
                  Alert("Shorted. ",Symbol()," ", OrderLots()," @ ",OrderOpenPrice(),". For new order, Reload EA.");
                  Comment("Short executed"," ","@ ",DoubleToStr(OrderOpenPrice(),Digits)," ","\nTake Profit= ",DoubleToStr(TP,Digits),"\nStop Loss =", DoubleToStr(SL,Digits)
                  ,";  At Risk: $", NormalizeDouble(  Lots * MathAbs(entry-stop)/Point*pip,2   ) 
                  ,"\n(Entry - S/L) = ", MathAbs((entry-stop)/Point)
                  );
                  comment="Short Executed @";
                 } 
            }
         else {
               x=GetLastError();
               x$="";
               if (x==130) x$=" Stop too Tight.";
               if (x==129) x$=" Invalid Price.";
               if (x!=130 && x!=129) x$=" Error Code: "+x;
               Print("Error opening Sell order : ",x); 
               Alert("Error Sell, ",Symbol(),x$);
               Comment("Error has occurred ", "on Part ",y,x$);
              }        
      }
   }


Place_Trade= false;  // we turn this to false for now, but we turn it back to True if any of the Place[y] are still true.  This way, Place_Trade will be true as long as a single Place[y] = true.
for (y=1; y<= Split_into; y++)
     {
      if (Place[y] == true) 
          {
           Place_Trade = true;
           y=Split_into + 99999;  // stop the loop after we find a true one.  And as long as there is a true one, Place_Trade will be true.
          }
     }
if (Place_Trade == False) ObjectDelete("Active On"); //if none of the Place[y] is true, the Place_Trade will be False.  So, delete the "Active On" flag.          
//----

   //Print("Place_Trade = ",Place_Trade, " target: ", Target_in_Pips*Point+Trade_Price1, " Stop: ", SL);
   return(0);
  }
//+------------------------------------------------------------------+

//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

int setup()
     {
      lomin = WindowPriceMin();
      himax = WindowPriceMax();
      hilorange= himax-lomin;  
 
      winbar1= WindowBarsPerChart()*0.4167;
      winbar2= WindowBarsPerChart()*0.5167131;
      winbar3= WindowBarsPerChart()*0.27169009;  
      winbar4= WindowBarsPerChart()*0.06589123;
      ObjectDelete("entry");    
      if (ObjectFind("entry") !=0 || ObjectType("entry") != OBJ_ARROW || ObjectGet("entry" ,OBJPROP_ARROWCODE) != SYMBOL_RIGHTPRICE ) 
          {
           ObjectDelete("entry");
           ObjectDelete("stop");
           ObjectDelete("t/p");
           ObjectDelete("ask line");
          }    
      ObjectCreate("entry",OBJ_ARROW,0,Time[winbar1],himax-hilorange/78);
      ObjectSet("entry", OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
      ObjectSet("entry", OBJPROP_COLOR, Entry_Color+temp);   
      
      ObjectCreate("stop",OBJ_ARROW,0,Time[winbar2],himax-hilorange/78);
      ObjectSet("stop", OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
      ObjectSet("stop", OBJPROP_COLOR, Stop_Color-temp);   
      
      ObjectCreate("t/p",OBJ_ARROW,0,Time[winbar1],himax+hilorange*33);
      ObjectSet("t/p", OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
      ObjectSet("t/p", OBJPROP_COLOR, Profit_Color);   
      
      ObjectCreate("ask line",2,0,Time[winbar1],himax+hilorange*33,Time[winbar1+3],himax+hilorange*30 );
      ObjectSet("ask line", OBJPROP_STYLE, STYLE_DOT);   
      ObjectSet("ask line", OBJPROP_BACK,0);
      ObjectSet("ask line", OBJPROP_RAY, 0); 
      
      ObjectCreate("Enter # of Lots Below.",OBJ_TEXT,0,Time[winbar3],himax+hilorange/80);
      ObjectSetText("Enter # of Lots Below.", "Lots",12,"Arial",LightBlue);
      //ObjectSet("Enter # of Lots Below.", OBJPROP_COLOR, Blue);   
      ObjectMove("Enter # of Lots Below.",0,Time[winbar3],himax);
      
      ObjectDelete("lll_lots$");          
      ObjectCreate("lll_lots$",OBJ_TEXT,0,Time[winbar4],himax); 

      ObjectDelete("Active ON");
      ObjectDelete("INACTIVE");
      ObjectCreate("INACTIVE",OBJ_TEXT,0, Time[winbar2], himax-hilorange/2.2);
      ObjectSetText("INACTIVE","INACTIVE!",35,"Arial",Red);  // if "INACTIVE" is on the chart, the text and location will be moved.  If it is not on the charts, this has no effect.
      return(0);            
     } 
      

//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


int readarrows()
     {
      bool window20seconds = -1;
      int x,xx, uu, uuu;
      string Lots$, LotsTemp$;
      //define some variables.
      datetime profittime, asktimeE,asktimeS;
      spread = Ask-Bid;
      //if "entry" was deleted, we setup() again:
      if (ObjectFind("entry") !=0 || ObjectType("entry") != OBJ_ARROW || ObjectGet("entry" ,OBJPROP_ARROWCODE) != SYMBOL_RIGHTPRICE ) 
          {
           setup();
          }
      if (ObjectFind("stop") !=0 || ObjectType("stop") != OBJ_ARROW || ObjectGet("stop" ,OBJPROP_ARROWCODE) != SYMBOL_RIGHTPRICE ) 
          {
           setup();
          }    
      //let's get some window sizes and such:  to move Lots text
      lomin = WindowPriceMin();
      himax = WindowPriceMax();
      hilorange= himax-lomin;  
      winbar1= WindowBarsPerChart()*0.3767;
      winbar2= WindowBarsPerChart()*0.51267131;
      winbar3= WindowBarsPerChart()*0.27169009;  
      winbar4= WindowBarsPerChart()*0.06589123;
      ObjectMove("Enter # of Lots Below.",0,Time[winbar3],himax);
      ObjectMove("lll_lots$",0,Time[winbar4],himax);
      //Let's get some values.
      tick1 = ObjectGet("entry",OBJPROP_PRICE1);                  
      toc1  = ObjectGet("stop", OBJPROP_PRICE1);
      if (tick2 == himax-hilorange/78 || toc2 == himax-hilorange/78) 
          { //this 'if' addresses when we are at the very beginning of the program.  If user removes "INACTIVE."  We won't make him have to have tick data come in twice before Active ON is turne on.
           tick2=tick1;
           toc2 =toc1;   //
          } 
      entry= NormalizeDouble(tick1,Digits);      
      stop = NormalizeDouble(toc1,Digits);      
      profittime=ObjectGet("entry",OBJPROP_TIME1);  //gets the time1 of entry label, so t/p can be lined up there.

        //----if the taggs have been moved, but the active tag has not been moved to the top of the screen, then, Ready is false.  HOWEVER! User must be careful.  For, if the Active Flag has been moved to the top of the screen, then the tick / toc check is not done. 
        //---- if the "Active/Inactive" text was moved to the top less than 20 seconds ago, we won't change it to "inactive"
        //---- but if the timelock of 20 seconds has expired, then it will change to inactive if user moves the entry or stop
        //---- flag.  In other words, user has 20 seconds to make fine tune adjustments to the entry/stop flag.  After that, if 
        //----he/she moves it again, we will require him to physically through the "Active" switch again.
      if   (TimeLocal() < timelock+Grace) window20seconds = true;
      else window20seconds = false;
      if ( (tick1!=tick2 && ready? == true && window20seconds==1) || (toc1!=toc2 && ready? == true && window20seconds==1) ) 
           {
            timelock=TimeLocal(); //(this is if the "active" has been throw to 'on', then everytime the labels are moved within the 20 second window, the user buys another 20 seconds of window20seconds time. 
           }
      if ( (tick1!=tick2 && ready?==1 && window20seconds==0)||(toc1!=toc2 && ready?==1 && window20seconds==0) )//if user moves the 'entry' or 'stop', and it is outside of the 20 second grace period, we will delete the "Active ON" sign.
           {
            ObjectDelete("Active ON");  // we don't have to specifically create "INACTIVE" or turn ready? to 0.  The Active?() will do that.
            ObjectCreate ("INACTIVE",OBJ_TEXT,0,Time[winbar1],himax-hilorange/1.59955);
            ObjectSetText("INACTIVE","Inactive!",35,"Arial",Red);
            ready?=0; 
           }
      tick2 = tick1;  //after checking if 1 and 2 are the same, you can set 2 = 1.  Then, if 1 changes to become different than 2, we know user moved it.   
      toc2=toc1;   //after the above check, we set toc2 to toc1, so we can check all over again.
      //asktimeE = ObjectGet("entry",OBJPROP_TIME1);
      //asktimeS = ObjectGet("stop",OBJPROP_TIME1);               
      if (entry>stop == true)  //this combo of if/else/if 3 lines will make it so that if entry = stop, then there is no trade.
          {
           Buy_Sell = "b";  
           profit=entry + (entry-stop)* RRR; // calculating the T/P based on RRR   
           ObjectMove("ask line",0,Time[0]+2*Period()*60,entry-spread); //we want to put a dash line spread points below the entry
           ObjectMove("ask line",1,Time[0]+7*Period()*60,entry-spread); //we want to put a dash line spread points below the entry                              
           ObjectSet("ask line", OBJPROP_COLOR, Entry_Color-10000);
          } 
      if (entry==stop)
          { 
           Buy_Sell = "no trade"; 
           profit = 0;
          }       
      if (entry<stop  == true)               
          {
           Buy_Sell = "s";
           profit=entry- MathAbs(entry-stop)*RRR;
           ObjectMove("ask line",1,Time[0]+2*Period()*60,stop-spread); //we want to put a dash line spread points below the entry
           ObjectMove("ask line",0,Time[0]+7*Period()*60,stop-spread); //we want to put a dash line spread points below the entry                              
           ObjectSet("ask line", OBJPROP_COLOR, Stop_Color-10000);            
          }
      if (entry!=stop && MathAbs(entry-stop) <10 * Point && ready? == true)
          {
           ObjectDelete("Active ON");
           Alert("MetaTrader Does not Allow Stop so Tight");
          } 
      ObjectMove("t/p",0,profittime,profit);
      // read the LOTS flag.
      LotsTemp$=ObjectDescription("Enter # of Lots Below.");
      uuu=StringGetChar(LotsTemp$,0); // we have to get through the first for loop check.  After that, the uuu is set within the for loop
      for (uu = 0; (uu<200 && uuu >= 48 && uuu <=57) || uuu==46 ; )
          {
           uuu=StringGetChar(LotsTemp$,uu);
           uu++;
          }
      uu--; //take away that last uu++ because of the way the increments are added in the for loop (ie they are added as the last step in the bracket.  So, you want to take that one back.          
      if (uu<=0)
         {
          LotsTemp$= "0000";
         }          
      LotsTemp$=StringSubstr(LotsTemp$,0,uu);
      lots=StrToDouble(LotsTemp$);
      ObjectSetText("Enter # of Lots Below.",DoubleToStr(lots,1)+" LOTS",13,"Arial",DodgerBlue);
      ObjectSet("Enter # of Lots Below.",OBJPROP_BACK,0);
      // Comment("\n ready? ",ready?, " b/s ", Buy_Sell, " entry ", entry, " stop ", stop, " t/p ", profit, " lots ",lots, " sprd ", spread);      
      Lots=lots;
      return(0);     
     } 
  
//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>  

int Rates_Lots()
    {
     int x,xx;
     double aud,chf,gbp,jpy,cad;     
     string sym$,Lots$;
     double range = NormalizeDouble(entry,Digits)-NormalizeDouble(stop,Digits);
          
     sym$ = StringSubstr(Symbol(),3,3);          
     aud=MarketInfo("AUDUSD",MODE_BID)*10;
     gbp=MarketInfo("GBPUSD",MODE_BID)*10;    
     cad=10/MarketInfo("USDCAD",MODE_BID);
     chf=10/MarketInfo("USDCHF",MODE_BID);
     jpy=1000/MarketInfo("USDJPY",MODE_BID); 
     
     Runit=NormalizeDouble(AccSize*Risk/100,2);       
     if (sym$ == "AUD" && range !=0)
         {
          //Lots=Runit/(MathAbs(entry-stop)/Point*aud);
          pip = aud;
         } 
     if (sym$ == "GBP"&& range !=0)
         {
          //Lots=Runit/(MathAbs(entry-stop)/Point*gbp);
          pip = gbp;
         } 
     if (sym$ == "CAD"&& range !=0)
         {
          //Lots=Runit/(MathAbs(entry-stop)/Point*cad);
          pip = cad;
         } 
     if (sym$ == "CHF"&& range !=0)
         {
          //Lots=Runit/(MathAbs(entry-stop)/Point*chf);
          pip = chf;
         } 
     if (sym$ == "JPY"&& range !=0)
         {
          //Lots=Runit/(MathAbs(entry-stop)/Point*jpy);
          pip=jpy;
         } 
     if (sym$ == "USD"&& range !=0)
         {
          //Lots=Runit/(MathAbs(entry-stop)/Point*10);
          pip=10;  
         }
     Lots=NormalizeDouble(Lots,1);         
     lots=Lots;
     Lots$=Lots;
     x=0;
     xx=0;
     /*
     while (x<200 && xx !=46)
           {
            xx = StringGetChar(Lots$,x);  //we keep going until we find '.'   .  x stops when xx = 46.  That is the position of the '.'
            x++;
           }
     Lots$=StringSubstr (Lots$,0,x+2); // This puts us with one place after the decimal.                
     ObjectSetText("Enter # of Lots Below.",Lots$,13,"Arial",LightBlue);
     */    
     //Comment(ready?, " $", NormalizeDouble(  Lots * MathAbs(entry-stop)/Point*pip,2   ), " Runit= $",Runit );
     Split();
     return(0);
    }  
     
     
//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>..

int Split()
    {//this splits up the lots to as many as 30 lots.
     int x,xx, y;
     int modulous,remainder,whole;
     int lll_lots = lots*10; //gets rid of the one decimal point
     string lll_lots$="";
     string lll_temp$="";
     remainder=lll_lots % Split_into;
     whole=lll_lots/Split_into;
     
     for (y =1; y<= Split_into; y++)
         {
          lll[y]=whole;
          if (remainder >0)
              {
               lll[y] +=1.000000;
               remainder--;
              }
          lll[y]/=10.000000;  //turn it back into 1 decimal point                 
          lll_temp$=lll[y];
          x=0;
          xx=0;
          while (x<200 && xx !=46)  //gets rid of the excess zeros after the first decimal.
                {                 
                 xx = StringGetChar(lll_temp$,x);  //we keep going until we find '.'   .  x stops when xx = 46.  That is the position of the '.'
                 x++;
                }
          lll_temp$=StringSubstr (lll_temp$,0,x+1); // This puts us with one place after the decimal. 
          lll_lots$=lll_lots$+lll_temp$;
          if (y < Split_into) lll_lots$ = lll_lots$ +"; ";  //we add a semi-colon to each number except the last one.                       
         }      
     lll_lots$=lll_lots$ + " lots.";  
     ObjectSetText("lll_lots$",lll_lots$,11,"Arial",Yellow);
     return(0);
    }     
    
//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

int active?()
     {//we placed an text object named "INACTIVE" during the init(), if this tag is now missing, we know the user has deleted it.  This means we are going active.
      double range = NormalizeDouble(entry,Digits)-NormalizeDouble(stop,Digits);
      if (ObjectFind("active")==0)
         {
          ready?=1;
          timelock=TimeLocal();
          ObjectDelete("INACTIVE");  //by doing this, with ready? = 0, and Inactive sign off the board, then the computer will think the user deleted the Inactive sign while ready? was zero.  This will cause the computer to make the trade activate.  This is a way to ensure that the trade is active.
          ObjectDelete("active");  // this is not the same sign as the "Active ON" sign.  Rather, active is something the users enters.
          ObjectCreate("Active ON",OBJ_TEXT,0,Time[winbar1],lomin+hilorange/25);
          ObjectSetText("Active ON","Trade Activated!");
         }    
      if (range==0 && ready?==1)
         {
          ObjectDelete("Active ON"); // if ready is 1, and we delete the "active on" label, then the active() will throw ready to 0 and objcreate "INACTIVE"
         }     
      if (ObjectFind("INACTIVE")!=0 && NormalizeDouble (entry, Digits)!= NormalizeDouble(stop,Digits) && ready? ==0 ) // we are trying to go from not ready to ready.
          {
           ready?=1;
           timelock=TimeLocal(); //I will use this to give a 20 second window for the user to move things around.
           ObjectDelete("Active ON"); //I know the "active ON" is not in win 0, but I am going to delete it jsut in case it is in another window.
           ObjectDelete("INACTIVE");  //deleted it for good measure.
           ObjectCreate("Active ON", OBJ_TEXT,0, Time[Bars-10], lomin/3);
           if (Buy_Sell == "b" && (Trade_Price1-Point) > Ask && ready? ==1)//A buy limit should be placed below Market
               { 
                Alert("Your Buy Limit is above ",Symbol()," Market Price.  Please correct");
                ready?=false;
                comment = "Error; Buy Limits should be placed below current Market Price ("+DoubleToStr(Ask,Digits)+").  You tried to place it @ ";
                ObjectDelete("Active ON");
                ObjectCreate ("INACTIVE",OBJ_TEXT,0,Time[Bars-10],lomin/3);
               }      
           if (Buy_Sell == "s" && (Trade_Price1+Point) < Bid && Trade_Price1 > 0 && ready? ==1)//A sell limit should be placed above Market
               {
                Alert("Your Sell Limit is below ",Symbol()," Market Price.  Please correct");
                ready?=false;
                comment = "Error; Sell Limits should be placed Above current Market Price ("+DoubleToStr(Bid,Digits)+"). You tried to place it @ ";
                ObjectDelete("Active ON");
                ObjectCreate ("INACTIVE",OBJ_TEXT,0,Time[Bars-10],lomin/3);
               }
          }               
      if (ObjectFind("Active ON") != 0  && ready? ==1)
          { // this 'if' is true if ready? was 1 and active flag was in win 0.  However, user has deleted the active on text.  So, we need to turn ready? to 0.
           ready?=0;  
           ObjectDelete("Active ON"); //I know the "active ON" is not in win 0, but I am going to delete it jsut in case it is in another window.
           ObjectDelete("INACTIVE");  //deleted it for good measure.
           ObjectCreate("INACTIVE",OBJ_TEXT, 0, Time [Bars-10], lomin/3);
          }             
      ObjectSetText("INACTIVE","NOT ACTIVE!!!",13,"Arial",Red);  // if "INACTIVE" is on the chart, the text and location will be moved.  If it is not on the charts, this has no effect.
      ObjectMove   ("INACTIVE",0, Time[winbar3], lomin+hilorange/25.9222);
      ObjectSet    ("INACTIVE",OBJPROP_ANGLE,2-1*TimeLocal()%4); // 2-1*1= 1 2-1*3 = -1; 3-2 = 0.  We are going from -24 to positive 24 degrees using this formula.
      ObjectSetText("Active ON", "Active!", 12, "Arial", Lime);
      ObjectMove   ("Active ON", 0, Time[winbar3], lomin+hilorange/25.921892);
      
      //if the trade has beein placed, change the saying on the board.
      if (Place_Trade != true ) 
          {
           ObjectDelete("Active ON"); //I know the "active ON" is not in win 0, but I am going to delete it jsut in case it is in another window.
           ObjectDelete("INACTIVE");  //deleted it for good measure.
           ObjectCreate("INACTIVE",OBJ_TEXT, 0, Time[winbar1], lomin+hilorange/27.197921324); 
           ObjectSetText( "INACTIVE","No further Trades will be Taken.",11,"Arial",Red);
          }           
      return(0);
     }
     
     



